import { EventEmitter, NgZone, OnDestroy, OnInit } from '@angular/core';
import * as THREE from 'three';
import type { AnyConstructor } from '../models';
import { NgtInstancesStore } from '../stores/instances.store';
import { NgtStore } from '../stores/store';
import * as i0 from "@angular/core";
export declare abstract class NgtMaterial<TMaterialParameters extends THREE.MaterialParameters = THREE.MaterialParameters, TMaterial extends THREE.Material = THREE.Material> implements OnInit, OnDestroy {
    #private;
    protected ngZone: NgZone;
    protected instancesStore: NgtInstancesStore;
    protected store: NgtStore;
    ngtId?: string;
    ready: EventEmitter<any>;
    set parameters(v: TMaterialParameters | undefined);
    get parameters(): TMaterialParameters | undefined;
    constructor(ngZone: NgZone, instancesStore: NgtInstancesStore, store: NgtStore);
    abstract materialType: AnyConstructor<TMaterial>;
    ngOnInit(): void;
    get material(): TMaterial;
    private convertColorToLinear;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMaterial<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtMaterial<any, any>, never, never, { "ngtId": "ngtId"; "parameters": "parameters"; }, { "ready": "ready"; }, never>;
}
